#include "Lapin.hpp"

Lapin::Lapin()
{
    vivant = true;
    age = 0;
    genre = 0;

    double tirageGenre = uniform(0, 1);
    if(tirageGenre <= PROBASEXEFEMININ)
    {
        genre = 1;
    }

    double tirageMaturite = uniform(0, 1);
    if(tirageMaturite <= CINQMOIS)
    {
        ageMaturite = 5;
    }
    else if(tirageMaturite <= SIXMOISOUMOINS)
    {
        ageMaturite = 6;
    }
    else if(tirageMaturite <= SEPTMOISOUMOINS)
    {
        ageMaturite = 7;
    }
    else if(tirageMaturite <= HUITMOISOUMOINS)
    {
        ageMaturite = 8;
    }
    else
    {
        ageMaturite = 8;
    }
}

/*
Lapin::~Lapin()
{
    cout << "Allez Tchaow\n";
}
*/

bool Lapin::survie()
{
    bool vivant = false;

    double tirageMort = uniform(0, 1);

    if(age < ageMaturite)
    {
        if(tirageMort <= IMMATURE)
        {
            vivant = true;
        }
    }
    else if (age < 10 * 12)
    {    
        if(tirageMort <= MATURE)
        {
            vivant = true;
        }
    }
    else if (age < 11 * 12)
    {
        if(tirageMort <= ONZIEMEANNEE)
        {
            vivant = true;
        }
    } 
    else if (age < 12 * 12)
    {
        if(tirageMort <= DOUXIEMEANNEE)
        {
            vivant = true;
        }
    }
    else if (age < 13 * 12)
    {
        if(tirageMort <= TREIZIEMEANNEE)
        {
            vivant = true;
        }
    }
    else if (age < 14 * 12)
    {
        if(tirageMort <= QUATORZIEMEANNEE)
        {
            vivant = true;
        }
    }
    else if (age < 15 * 12)
    {
        if(tirageMort <= QUINZIEMEANNEE)
        {
            vivant = true;
        }
    }
    
    age++;

    return vivant;
}



bool Lapin::fairePetits()
{
    bool fairePetits = false;

    if(genre == 1) // femelle ?
    {
        if(age - 1 >= ageMaturite) // suffisamment mature pour procréer ?
        {
            double tirageProcreation = uniform(0, 1);
            if(tirageProcreation <= PROBAPROCREATION)
            {
                fairePetits = true;
            }
        }
    }

    return fairePetits;
}


void Lapin::afficherLapin()
{
    cout << "vivant : " << vivant << " (0 mort, 1 vivant)\n";
    cout << "genre : " << genre << " (0 male, 1 femelle)\n";
    cout << "age : " << age << " (en mois)\n";
    cout << "age de maturité : " << ageMaturite << " (en mois)\n";
}